from bloonix.heaven import H

class Controller:
    def startup(self):
        H.route("/config/hosts/:id/action/:action", "action")
        self.actions = [
            "acknowledge", "clear-acknowledgement",
            "enable", "disable", "downtime",
            "enable-notifications", "disable-notifications",
            "force-check",
        ]

    def auto(self, opts):
        H.cache["host"] = H.model.db.host.get(opts["id"])
        if not H.cache["host"]:
            return H.plugin.error.set("err-600")
        if opts["action"] not in self.actions:
            return H.plugin.error.set("err-404")
        return True

    def action(self, opts):
        if not H.plugin.token.check():
            return

        host = H.cache["host"]
        host_id = opts["id"]
        action = opts["action"]
        table = None
        data = {}

        if action == "acknowledge":
            data["acknowledged"] = 1
            table = "service"
        elif action == "clear-acknowledgement":
            data["acknowledged"] = 0
            table = "service"
        elif action == "enable" and host["enabled"] == 0:
            data["enabled"] = 1
            table = "host"
        elif action == "disable" and host["enabled"] == 1:
            data["enabled"] = 0
            table = "host"
        elif action == "enable-notifications" and host["notification_enabled"] == 0:
            data["notification_enabled"] = 1
            table = "host"
        elif action == "disable-notifications" and host["notification_enabled"] == 1:
            data["notification_enabled"] = 0
            table = "host"
        elif action == "force-check":
            data["force_check"] = 1
            table = "service"

        if len(data):
            if table == "service":
                H.model.db.service.update_by_col("host_id", host_id, data)
            elif table == "host":
                H.model.db.host.update_by_id(host_id, data)

