import time
from bloonix.dbi.crud import CRUD
from bloonix.heaven import H

class Notification(CRUD):
    def list_by_host_id(self, query_data, host_id):
        return self.query(
            distinct=True,
            query=query_data,
            count="id",
            parse_int=["id", "time", "success"],
            table=[
                "notification", [
                    "id",
                    "time",
                    "host_id",
                    "message_service_name",
                    "send_to",
                    "message",
                    "contact",
                    "success",
                    "error",
                ]
            ],
            condition=["where", ["host_id", host_id]],
            order=["desc", "time"],
        )

    def list(self, query_data):
        query = H.plugin.role.filter_notifications(
            distinct=True,
            query=query_data,
            count="id",
            parse_int=["id", "time", "success"],
            table=[
                "notification", [
                    "id",
                    "time",
                    "host_id",
                    "message_service_name",
                    "send_to",
                    "message",
                    "contact",
                    "success",
                    "error",
                ]
            ],
            order=["desc", "time"],
        )
        return self.query(**query)

    def count_by_host_id(self, host_id):
        stmt, bind = self.sql.select(
            count="id",
            table="notification",
            condition=[
                "where", ["host_id", host_id],
                "and", ["time", ">=", int(time.time()) - 86400],
            ])
        return self.dbi.fetchone(stmt, bind)["count"]
