from bloonix.heaven import H
from bloonix import mstatus
from bloonix.genattr import GenAttr

class Result:
    def search(self, service_id, from_time, to_time=None, status=None):
        condition = [
            "where", ["service_id", service_id],
            "and", ["time", ">=", from_time],
        ]
        if to_time:
            condition.append("and")
            condition.append(["time", "<=", to_time])
        if status:
            if not isinstance(status, list):
                status = [status]
            ok = True
            for s in status:
                if s not in mstatus.CODES:
                    ok = False
            if ok is True:
                condition.append("and")
                condition.append("status", "in", status)

        stmt, bind = self.sql.select(
            table="result",
            columns=["time", "status", "message"],
            condition=condition,
            order=["desc", "time"])

        stmt_count, bind_count = self.sql.select(
            table="result",
            count="time",
            condition=condition)

        return GenAttr(
            data=self.dbi.fetchall(stmt, bind),
            total=self.dbi.count(stmt_count, bind_count),
            success=True)

    def data(self, service_id, timestamp):
        stmt, bind = self.sql.select(
            table="result",
            columns=["*"],
            condition=[
                "where", ["service_id", service_id],
                "and", ["time", "=", timestamp],
            ])
        return self.dbi.fetchone(stmt, bind)
