class Stat:
    def data_by_item_id(
            self, service_id, item_id, from_time,
            to_time=None, with_satellite=None,
            satellite_id=None):
        return self.data(
            service_id=service_id,
            item_id=item_id,
            from_time=from_time,
            to_time=to_time,
            with_satellite=with_satellite,
            satellite_id=satellite_id)

    def data(
            self, service_id, from_time, to_time=None,
            item_id=None, with_satellite=None,
            satellite_id=None, order="asc"):
        condition = [
            "where", ["service_id", service_id],
            "and", ["time", ">=", from_time],
        ]
        columns = [
            "time", "item_id", "value",
        ]
        if item_id:
            condition.append("and")
            condition.append(["item_id", item_id])
        if to_time:
            condition.append("and")
            condition.append(["time", "<=", to_time])
        if satellite_id and len(satellite_id):
            condition.append("and")
            condition.append(["satellite_id", satellite_id])
        if with_satellite:
            columns.append("satellite_id")
        stmt, bind = self.sql.select(
            table="stat",
            columns=columns,
            condition=condition,
            order=[order, "time"])
        return self.dbi.fetchall(stmt, bind)
