from bloonix.heaven import H
import re

class PasswordPolicy:
    def check_characters(self, string):
        param = H.model.db.sys_options.get_keys_by_match("password_policy%")

        if "any" in param["password_policy"]:
            return True

        for cls in param["password_policy"]:
            if cls == "special":
                key = "password_policy_special_compiled"
            else:
                key = "password_policy_%s" % cls
            if not re.search("[%s]" % param[key], string):
                return False

        return True

    def must_have_characters(self):
        param = H.model.db.sys_options.get_keys_by_match("password_policy%")

        if "any" in param["password_policy"]:
            return {"any": "any"}

        signs = {}
        for cls in param["password_policy"]:
            key = "password_policy_%s" % cls
            signs[key] = param[key]
        return signs
